unbound: respip/respip.h File Reference

unbound 0.1

Data Structures | Functions
respip.h File Reference

This file contains a module that selectively modifies query responses based on their AAAA/A IP addresses. More...

`#include "util/module.h"`
`#include "services/localzone.h"`
`#include "util/locks.h"`

## Data Structures
struct | respip_set
| Conceptual set of IP addresses for response AAAA or A records that should trigger special actions. More...
struct | resp_addr
| An address span with response control information. More...
struct | respip_client_info
| Client-specific attributes that can affect IP-based actions. More...
struct | respip_action_info
| Data items representing the result of response-ip processing. More...

## Functions
struct respip_set * | respip_set_create (void)
| Create response IP set.
void | respip_set_delete (struct respip_set *set)
| Delete response IP set.
int | respip_global_apply_cfg (struct respip_set *set, struct config_file *cfg)
| Apply response-ip config settings to the global (default) view.
int | respip_views_apply_cfg (struct views *vs, struct config_file *cfg, int *have_view_respip_cfg)
| Apply response-ip config settings in named views.
int | respip_merge_cname (struct reply_info *base_rep, const struct query_info *qinfo, const struct reply_info *tgt_rep, const struct respip_client_info *cinfo, int must_validate, struct reply_info **new_repp, struct regional *region, struct auth_zones *az)
| Merge two replies to build a complete CNAME chain.
int | respip_rewrite_reply (const struct query_info *qinfo, const struct respip_client_info *cinfo, const struct reply_info *rep, struct reply_info **new_repp, struct respip_action_info *actinfo, struct ub_packed_rrset_key **alias_rrset, int search_only, struct regional *region, struct auth_zones *az, int *rpz_passthru)
| See if any IP-based action should apply to any IP address of AAAA/A answer record in the reply.
struct module_func_block * | respip_get_funcblock (void)
| Get the response-ip function block.
int | respip_init (struct module_env *env, int id)
| response-ip init
void | respip_deinit (struct module_env *env, int id)
| response-ip deinit
void | respip_operate (struct module_qstate *qstate, enum module_ev event, int id, struct outbound_entry *outbound)
| response-ip operate on a query
void | respip_inform_super (struct module_qstate *qstate, int id, struct module_qstate *super)
| inform response-ip super
void | respip_clear (struct module_qstate *qstate, int id)
| response-ip cleanup query state
struct rbtree_type * | respip_set_get_tree (struct respip_set *set)
| returns address of the IP address tree of the specified respip set; returns NULL for NULL input; exists for test purposes only
enum respip_action | resp_addr_get_action (const struct resp_addr *addr)
| returns respip action for the specified node in the respip address returns respip_none for NULL input; exists for test purposes only
struct ub_packed_rrset_key * | resp_addr_get_rrset (struct resp_addr *addr)
| returns rrset portion of the specified node in the respip address tree; returns NULL for NULL input; exists for test purposes only
size_t | respip_get_mem (struct module_env *env, int id)
| response-ip alloc size routine
int | respip_set_is_empty (const struct respip_set *set)
| respip set emptiness test
void | respip_inform_print (struct respip_action_info *respip_actinfo, uint8_t *qname, uint16_t qtype, uint16_t qclass, struct local_rrset *local_alias, struct sockaddr_storage *addr, socklen_t addrlen)
| print log information for a query subject to an inform or inform-deny response-ip action.
struct resp_addr * | respip_sockaddr_find_or_create (struct respip_set *set, struct sockaddr_storage *addr, socklen_t addrlen, int net, int create, const char *ipstr)
| Find resp_addr in tree, create and add to tree if it does not exist.
int | respip_enter_rr (struct regional *region, struct resp_addr *raddr, uint16_t rrtype, uint16_t rrclass, time_t ttl, uint8_t *rdata, size_t rdata_len, const char *rrstr, const char *netblockstr)
| Add RR to resp_addr's RRset.
void | respip_sockaddr_delete (struct respip_set *set, struct resp_addr *node)
| Delete resp_addr node from tree.
struct ub_packed_rrset_key * | respip_copy_rrset (const struct ub_packed_rrset_key *key, struct regional *region)
| make a deep copy of 'key' in 'region'.

## Detailed Description

This file contains a module that selectively modifies query responses based on their AAAA/A IP addresses.

## Function Documentation

## ◆ respip_set_create()

struct respip_set * respip_set_create | ( | void |  | ) |

Create response IP set.

Returns
  new struct or NULL on error.

References addr_tree_init(), and regional_create().

Referenced by daemon_fork(), respip_conf_actions_test(), respip_conf_data_test(), respip_views_apply_cfg(), rpz_clear(), rpz_create(), and view_and_respipchecks().

## ◆ respip_set_delete()

void respip_set_delete | ( | struct respip_set * | set | ) |

Delete response IP set.

Parameters

  set | to delete.

## ◆ respip_global_apply_cfg()

int respip_global_apply_cfg | ( | struct respip_set * | set,
|  | struct config_file * | cfg )

Apply response-ip config settings to the global (default) view.

It assumes exclusive access to set (no internal locks).

Parameters

  set | processed global respip config data
  cfg | config data.

Returns
  1 on success, 0 on error.

References config_file::num_tags, config_file::respip_actions, config_file::respip_data, config_file::respip_tags, and config_file::tagname.

Referenced by daemon_fork(), respip_conf_actions_test(), respip_conf_data_test(), and view_and_respipchecks().

## ◆ respip_views_apply_cfg()

int respip_views_apply_cfg | ( | struct views * | vs,
|  | struct config_file * | cfg,
|  | int * | have_view_respip_cfg )

Apply response-ip config settings in named views.

Parameters

  vs | view structures with processed config data
  cfg | config data.
  have_view_respip_cfg | set to true if any named view has respip configuration; otherwise set to false

Returns
  1 on success, 0 on error.

Apply response-ip config settings in named views.

This additional iteration through view configuration data is expected to not have significant performance impact (or rather, its performance impact is not expected to be prohibitive in the configuration processing phase).

if no respip config for this view then there's nothing to do; note that even though respip data must go with respip action, we're checking for both here because we want to catch the case where the respip action is missing while the data is present

References rbtree_type::count, view::lock, log_err(), config_view::name, config_view::next, config_view::respip_actions, config_view::respip_data, view::respip_set, respip_set_create(), config_file::views, and views_find_view().

Referenced by daemon_fork(), respip_view_conf_actions_test(), respip_view_conf_data_test(), and view_and_respipchecks().

## ◆ respip_merge_cname()

int respip_merge_cname | ( | struct reply_info * | base_rep,
|  | const struct query_info * | qinfo,
|  | const struct reply_info * | tgt_rep,
|  | const struct respip_client_info * | cinfo,
|  | int | must_validate,
|  | struct reply_info ** | new_repp,
|  | struct regional * | region,
|  | struct auth_zones * | az )

Merge two replies to build a complete CNAME chain.

It appends the content of 'tgt_rep' to 'base_rep', assuming (but not checking) the former ends with a CNAME and the latter resolves its target. A merged new reply will be built using 'region' and *new_repp will point to the new one on success. If the target reply would also be subject to a response-ip action for 'cinfo', this function uses 'base_rep' as the merged reply, ignoring 'tgt_rep'. This is for avoiding cases like a CNAME loop or failure of applying an action to an address. RRSIGs in 'tgt_rep' will be excluded in the merged reply, as the resulting reply is assumed to be faked due to a response-ip action and can't be considered secure in terms of DNSSEC. The caller must ensure that neither 'base_rep' nor 'tgt_rep' can be modified until this function returns.

Parameters

  base_rep | the reply info containing an incomplete CNAME.
  qinfo | query info corresponding to 'base_rep'.
  tgt_rep | the reply info that completes the CNAME chain.
  cinfo | client info corresponding to 'base_rep'.
  must_validate | whether 'tgt_rep' must be DNSSEC-validated.
  new_repp | pointer placeholder for the merged reply. will be intact on error.
  region | allocator to build *new_repp.
  az | auth zones containing RPZ information.

Returns
  1 on success, 0 on error.

References reply_info::an_numrrsets, reply_info::flags, FLAGS_GET_RCODE, FLAGS_SET_RCODE, log_info(), respip_copy_rrset(), respip_none, respip_rewrite_reply(), reply_info::rrsets, sec_status_bogus, and reply_info::security.

Referenced by answer_from_cache(), mesh_serve_expired_callback(), and respip_inform_super().

## ◆ respip_rewrite_reply()

int respip_rewrite_reply | ( | const struct query_info * | qinfo,
|  | const struct respip_client_info * | cinfo,
|  | const struct reply_info * | rep,
|  | struct reply_info ** | new_repp,
|  | struct respip_action_info * | actinfo,
|  | struct ub_packed_rrset_key ** | alias_rrset,
|  | int | search_only,
|  | struct regional * | region,
|  | struct auth_zones * | az,
|  | int * | rpz_passthru )

See if any IP-based action should apply to any IP address of AAAA/A answer record in the reply.

If so, apply the action. In some cases it rewrites the reply rrsets, in which case *new_repp will point to the updated reply info. Depending on the action, some of the rrsets in 'rep' will be shallow-copied into '*new_repp'; the caller must ensure that the rrsets in 'rep' are valid throughout the lifetime of *new_repp, and it must provide appropriate mutex if the rrsets can be shared by multiple threads.

Parameters

  qinfo | query info corresponding to the reply.
  cinfo | client-specific info to identify the best matching action. can be NULL.
  rep | original reply info. must not be NULL.
  new_repp | can be set to the rewritten reply info (intact on failure).
  actinfo | result of response-ip processing
  alias_rrset | must not be NULL.
  search_only | if true, only check if an action would apply. actionp will be set (or intact) accordingly but the modified reply won't be built.
  az | auth zones containing RPZ information.
  region | allocator to build *new_repp.
  rpz_passthru | keeps track of query state can have passthru that stops further rpz processing. Or NULL for cached answer processing.

Returns
  1 on success, 0 on error.

Try to use response-ip config from the view first; use global response-ip config if we don't have the view or we don't have the matching per-view config (and the view allows the use of global data in this case). Note that we lock the view even if we only use view members that currently don't change after creation. This is for safety for future possible changes as the view documentation seems to expect any of its member can change in the view's lifetime. Note also that we assume 'view' is valid in this function, which should be safe (see unbound bug #1191)

for per-view respip directives the action can only be direct (i.e. not tag-based)

References resp_addr::action, addr_tree_node::addr, addr_to_str(), addr_tree_node::addrlen, lruhash_entry::data, resp_addr::data, dname_str(), ub_packed_rrset_key::entry, view::isfirst, LDNS_RR_TYPE_ANY, LDNS_RR_TYPE_CNAME, local_data_find_tag_action(), auth_zone::lock, resp_addr::lock, view::lock, log_assert, log_err(), addr_tree_node::net, resp_addr::node, populate_action_info(), query_info::qname, query_info::qtype, rdata2sockaddr(), respip_addr_lookup(), respip_always_deny, respip_always_nodata, respip_always_nxdomain, respip_always_refuse, respip_always_transparent, respip_data_answer(), respip_nodata_answer(), respip_none, view::respip_set, ub_packed_rrset_key::rk, auth_zone::rpz, rpz_action_to_string(), auth_zone::rpz_az_next, auth_zones::rpz_first, auth_zones::rpz_lock, reply_info::rrsets, resp_addr::taglen, resp_addr::taglist, taglist_intersect(), packed_rrset_key::type, VERB_ALGO, verbose(), and verbosity.

Referenced by apply_respip_action(), respip_merge_cname(), and respip_operate().

## ◆ respip_get_funcblock()

struct module_func_block * respip_get_funcblock | ( | void |  | ) |

Get the response-ip function block.

Returns
  : function block with function pointers to response-ip methods.

References respip_block.

Referenced by module_funcs_avail().

## ◆ respip_set_is_empty()

int respip_set_is_empty | ( | const struct respip_set * | set | ) |

respip set emptiness test

Parameters

  set | respip set to test

Returns
  0 if the specified set exists (non-NULL) and is non-empty; otherwise returns 1

References rbtree_type::count.

Referenced by daemon_fork().

## ◆ respip_inform_print()

void respip_inform_print | ( | struct respip_action_info * | respip_actinfo,
|  | uint8_t * | qname,
|  | uint16_t | qtype,
|  | uint16_t | qclass,
|  | struct local_rrset * | local_alias,
|  | struct sockaddr_storage * | addr,
|  | socklen_t | addrlen )

print log information for a query subject to an inform or inform-deny response-ip action.

Parameters

  respip_actinfo | response-ip information that causes the action
  qname | query name in the context, will be ignored if local_alias is non-NULL.
  qtype | query type, in host byte order.
  qclass | query class, in host byte order.
  local_alias | set to a local alias if the query matches an alias in a local zone. In this case its owner name will be considered the actual query name.
  addr | the client's source address and port.
  addrlen | the client's source address length.

References addr_to_str(), packed_rrset_key::dname, log_nametypeclass(), ub_packed_rrset_key::rk, rpz_action_to_string(), and local_rrset::rrset.

Referenced by apply_respip_action(), mesh_query_done(), and mesh_serve_expired_callback().

## ◆ respip_sockaddr_find_or_create()

struct resp_addr * respip_sockaddr_find_or_create | ( | struct respip_set * | set,
|  | struct sockaddr_storage * | addr,
|  | socklen_t | addrlen,
|  | int | net,
|  | int | create,
|  | const char * | ipstr )

Find resp_addr in tree, create and add to tree if it does not exist.

Parameters

  set | struct containing the tree and region to alloc new node on. should hold write lock.
  addr | address to look up.
  addrlen | length of addr.
  net | netblock to lookup.
  create | create node if it does not exist when 1.
  ipstr | human redable ip string, for logging.

Returns
  newly created of found node, not holding lock.

References addr_tree_find(), addr_tree_insert(), log_err(), log_warn(), addr_tree_node::node, resp_addr::node, regional_alloc_zero(), and respip_none.

Referenced by respip_find_or_create().

## ◆ respip_enter_rr()

int respip_enter_rr | ( | struct regional * | region,
|  | struct resp_addr * | raddr,
|  | uint16_t | rrtype,
|  | uint16_t | rrclass,
|  | time_t | ttl,
|  | uint8_t * | rdata,
|  | size_t | rdata_len,
|  | const char * | rrstr,
|  | const char * | netblockstr )

Add RR to resp_addr's RRset.

Create RRset if not existing.

Parameters

  region | region to alloc RR(set).
  raddr | resp_addr containing RRset. Must hold write lock.
  rrtype | RR type.
  rrclass | RR class.
  ttl | TTL.
  rdata | RDATA.
  rdata_len | length of rdata.
  rrstr | RR as string, for logging
  netblockstr | netblock as string, for logging

Returns
  0 on error

Add RR to resp_addr's RRset.

References addr_tree_node::addr, lruhash_entry::data, resp_addr::data, ub_packed_rrset_key::entry, LDNS_RR_TYPE_A, LDNS_RR_TYPE_AAAA, LDNS_RR_TYPE_CNAME, log_err(), new_rrset(), resp_addr::node, ub_packed_rrset_key::rk, rrset_insert_rr(), and packed_rrset_key::type.

## ◆ respip_sockaddr_delete()

void respip_sockaddr_delete | ( | struct respip_set * | set,
|  | struct resp_addr * | node )

Delete resp_addr node from tree.

Parameters

  set | struct containing tree. Must hold write lock.
  node | node to delete. Not locked.

References addr_tree_init_parents(), addr_tree_init_parents_node(), resp_addr::node, rbtree_delete(), and rbtree_previous().

## ◆ respip_copy_rrset()

struct ub_packed_rrset_key * respip_copy_rrset | ( | const struct ub_packed_rrset_key * | key,
|  | struct regional * | region )

make a deep copy of 'key' in 'region'.

This is largely derived from packed_rrset_copy_region() and packed_rrset_ptr_fixup(), but differs in the following points:

- It doesn't assume all data in 'key' are in a contiguous memory region. Although that would be the case in most cases, 'key' can be passed from a lower-level module and it might not build the rrset to meet the assumption. In fact, an rrset specified as response-ip-data or generated in local_data_find_tag_datas() breaks the assumption. So it would be safer not to naively rely on the assumption. On the other hand, this function ensures the copied rrset data are in a contiguous region so that it won't cause a disruption even if an upper layer module naively assumes the memory layout.
- It doesn't copy RRSIGs (if any) in 'key'. The rrset will be used in a reply that was already faked, so it doesn't make much sense to provide partial sigs even if they are valid themselves.
- It doesn't adjust TTLs as it basically has to be a verbatim copy of 'key' just allocated in 'region' (the assumption is necessary TTL adjustment has been already done in 'key').

This function returns the copied rrset key on success, and NULL on memory allocation failure.

References packed_rrset_data::count, lruhash_entry::data, packed_rrset_key::dname, packed_rrset_key::dname_len, ub_packed_rrset_key::entry, lruhash_entry::hash, ub_packed_rrset_key::id, lruhash_entry::key, regional_alloc(), regional_alloc_init(), regional_alloc_zero(), ub_packed_rrset_key::rk, packed_rrset_data::rr_data, packed_rrset_data::rr_len, packed_rrset_data::rr_ttl, and packed_rrset_data::rrsig_count.

Referenced by make_soa_ubrrset(), respip_data_answer(), respip_merge_cname(), rpz_apply_cname_override_action(), and rpz_synthesize_cname_override_msg().